<?php
/**
 * User: MHK
 * Date: 19/05/2021
 */

namespace Shahid\Video;

/**
 * Class Audio
 * @package Shahid\Video
 */
class Audio
{
    protected $URI;
    protected $GROUP_ID;
    protected $CHANNELS;
    protected $NAME;
    protected $LANGUAGE;
    protected $DEFAULT;
    protected $AUTOSELECT;

    /**
     * Audio constructor.
     *
     * @param $URI
     * @param $GROUP_ID
     * @param $CHANNELS
     * @param $NAME
     * @param $LANGUAGE
     * @param string $DEFAULT
     * @param string $AUTOSELECT
     */
    function __construct($URI, $GROUP_ID, $CHANNELS, $NAME, $LANGUAGE, $DEFAULT = 'NO', $AUTOSELECT = 'NO')
    {
        $this->URI = $URI;
        $this->GROUP_ID = $GROUP_ID;
        $this->CHANNELS = $CHANNELS;
        $this->NAME = $NAME;
        $this->LANGUAGE = $LANGUAGE;
        $this->DEFAULT = $DEFAULT;
        $this->AUTOSELECT = $AUTOSELECT;
    }

    /**
     * @return mixed
     */
    public function getURI()
    {
        return $this->URI;
    }

    /**
     * @return mixed
     */
    public function getGROUPID()
    {
        return $this->GROUP_ID;
    }

    /**
     * @return mixed
     */
    public function getCHANNELS()
    {
        return $this->CHANNELS;
    }

    /**
     * @return bool
     */
    public function isDEFAULT()
    {
        return $this->DEFAULT == 'YES';
    }

    /**
     * @return bool
     */
    public function isAUTOSELECT()
    {
        return $this->AUTOSELECT == 'YES';
    }

    /**
     * @return float|int
     */
    public function index()
    {
        return $this->getLANGUAGE();
    }

    /**
     * @return mixed
     */
    public function getLANGUAGE()
    {
        return $this->LANGUAGE;
    }

    /**
     * @return string
     */
    public function __toString()
    {
        return "Audio: {$this->getNAME()}";
    }

    /**
     * @return mixed
     */
    public function getNAME()
    {
        return $this->NAME;
    }
}