<?php

namespace Shahid\Video;


class Episode extends shahidable
{
    const API_URL = 'https://api2.shahid.net/proxy/v2/playout/new/url/{id}';
    const URLS
        = [
            [
                'ID_URL' => '/^https?:\/\/shahid\.mbc\.net\/\w+\/series\/[\w\d%!-]+\/episode-(\d+)$/',
                'NAME_URL' => '/^https?:\/\/shahid\.mbc\.net\/\w+\/series\/([\w\d%!-]+)\/episode-\d+$/',
                'SAISON_URL' => '/^https?:\/\/shahid\.mbc\.net\/\w+\/series\/[\w\d%!-]+-(\d+)-[\w\d%!-]+-\d+\/episode-\d+$/',
                'EPISODE_URL' => '/^https?:\/\/shahid\.mbc\.net\/\w+\/series\/[\w\d%!-]+-\d+-[\w\d%!-]+-(\d+)\/episode-\d+$/',
            ],
            [
                'ID_URL' => '/^https?:\/\/shahid\.mbc\.net\/\w+\/series\/[\w\d%!-]+\/clip-(\d+)$/',
                'NAME_URL' => '/^https?:\/\/shahid\.mbc\.net\/\w+\/series\/([\w\d%!-]+)\/clip-\d+$/',
                'SAISON_URL' => '/^https?:\/\/shahid\.mbc\.net\/\w+\/series\/[\w\d%!-]+-(\d+)-[\w\d%!-]+-\d+\/clip-\d+$/',
                'EPISODE_URL' => '/^https?:\/\/shahid\.mbc\.net\/\w+\/series\/[\w\d%!-]+-\d+-[\w\d%!-]+-(\d+)\/clip-\d+$/',
            ],
            [
                'ID_URL' => '/^https?:\/\/shahid\.mbc\.net\/\w+\/shows\/[\w\d%!-]+\/episode-(\d+)$/',
                'NAME_URL' => '/^https?:\/\/shahid\.mbc\.net\/\w+\/shows\/([\w\d%!-]+)\/episode-\d+$/',
                'SAISON_URL' => '/^https?:\/\/shahid\.mbc\.net\/\w+\/shows\/[\w\d%!-]+-(\d+)-[\w\d%!-]+-\d+\/episode-\d+$/',
                'EPISODE_URL' => '/^https?:\/\/shahid\.mbc\.net\/\w+\/shows\/[\w\d%!-]+-\d+-[\w\d%!-]+-(\d+)\/episode-\d+$/',
            ],
        ];

    /**
     * @return mixed|string|null
     */
    public function getSaison()
    {
        if (!$this->getSAISON_URL()) return null;
        preg_match($this->getSAISON_URL(), $this->url, $matches);
        if (!empty($matches[1])) {
            $saison = $matches[1];
            if ((int)$saison < 10) $saison = "0{$saison}";
            return $saison;
        }
        return null;
    }

    /**
     * @return mixed|null
     */
    protected function getSAISON_URL()
    {
        return $this::URLS[$this->index]['SAISON_URL'] ?? null;
    }

    /**
     * @return mixed|string|null
     */
    public function getEpisode()
    {
        if (!$this->getEPISODE_URL()) return null;
        preg_match($this->getEPISODE_URL(), $this->url, $matches);
        if (!empty($matches[1])) {
            $episode = $matches[1];
            if ((int)$episode < 10) $episode = "0{$episode}";
            return $episode;
        }
        return null;
    }

    /**
     * @return mixed|null
     */
    protected function getEPISODE_URL()
    {
        return $this::URLS[$this->index]['EPISODE_URL'] ?? null;
    }
}