<?php

namespace Shahid\Video;


use FFMpeg\FFMpeg;

/**
 * Class PlayLoad
 * @package Shahid\Video
 * @deprecated
 */
class PlayLoadOld
{
    /**
     * @var ShahidOld
     * @deprecated
     */
    protected $shahid;
    /**
     * @var string
     * @deprecated
     */
    protected $fileName;
    /**
     * @var string
     * @deprecated
     */
    protected $default_quality;

    /**
     * PlayLoadOld constructor.
     *
     * @param FFMpeg $ffmpeg
     * @param shahidable $shahidable
     * @param null $fileName
     * @param null $default_quality
     * @deprecated
     */
    public function __construct(FFMpeg $ffmpeg, shahidable $shahidable, $fileName = null, $default_quality = null)
    {
        $this->shahid = new ShahidOld($shahidable, $ffmpeg);
        $this->fileName = $fileName;
        $this->default_quality = $default_quality;
    }

    /**
     * @param shahidable $shahidable
     * @param FFMpeg $ffmpeg
     * @param null $fileName
     * @param null $default_quality
     *
     * @return array|false
     * @throws \GuzzleHttp\Exception\GuzzleException
     * @deprecated
     */
    public static function playLoadGet(FFMpeg $ffmpeg, shahidable $shahidable, $fileName = null, $default_quality = null)
    {
        return (new static($ffmpeg, $shahidable, $fileName, $default_quality))->get();
    }

    /**
     * @return array|false
     * @throws \GuzzleHttp\Exception\GuzzleException
     * @deprecated
     */
    public function get()
    {
        preg_match('/.+: (\d+)/', shell_exec('chcp'), $matches);
        $chcp = $matches[1] ?? 65001;
        if (!$quality = $this->shahid->quality($this->default_quality, $quality)) return false;
        shell_exec("chcp {$chcp}");
        $extra_title = "_[{$quality->p()}][{$quality->bps()}]";
        $fileNameByTitle = !empty($this->fileName) ? "{$this->fileName}{$extra_title}.mp4" : $this->shahid->fileName($extra_title);
        $fileNameById = "{$this->shahid->getId()}{$extra_title}.mp4";
        return [
            'fileNameByTitle' => $fileNameByTitle,
            'fileNameById' => $fileNameById,
            'url' => $quality->getUri(),
            'ffmpegByTitle' => "ffmpeg -y -i \"{$quality->getUri()}\" -c copy -bsf:a aac_adtstoasc \"{$fileNameByTitle}\"",
            'ffmpegById' => "ffmpeg -y -i \"{$quality->getUri()}\" -c copy -bsf:a aac_adtstoasc \"{$fileNameById}\"",
        ];
    }
}