<?php

namespace Shahid\Video;

use Chrisyue\PhpM3u8\Facade\ParserFacade;
use Chrisyue\PhpM3u8\Stream\TextStream;
use FFMpeg\FFMpeg;
use FFMpegMy\Media\VideoMy;
use FFMpegMy\Media\X264My;
use Shahid\Command\console;
use Shahid\Command\UserChose;
use Symfony\Component\DomCrawler\Crawler;

/**
 * Class Shahid
 * @package FFMpegMy\Media
 * @deprecated
 */
class ShahidOld
{
    /**
     * @deprecated
     */
    const MAX_PHP_VERSION = '7.4.0';
    /**
     * @deprecated
     */
    const MIN_PHP_VERSION = '7.2.0';
    /**
     * @var int|mixed
     * @deprecated
     */
    protected $id;
    /**
     * @var mixed|string
     * @deprecated
     */
    protected $name;
    /**
     * @var \stdClass
     * @deprecated
     */
    protected $playout;
    /**
     * @var \stdClass
     * @deprecated
     */
    protected $json;
    /**
     * @var string
     * @deprecated
     */
    protected $m3u8;
    /**
     * @deprecated
     */
    protected $m3u8_1080;
    /**
     * @var ParserFacade
     * @deprecated
     */
    protected $parser;
    /**
     * @deprecated
     */
    protected $dumper;
    /**
     * @var shahidable
     * @deprecated
     */
    protected $shahidable;
    /**
     * @var \FFMpeg\FFMpeg
     * @deprecated
     */
    protected $ffmpeg;

    /**
     * Shahid constructor.
     *
     * @param shahidable $shahidable
     * @param \FFMpeg\FFMpeg $ffmpeg
     *
     * @deprecated
     */
    public function __construct(shahidable $shahidable, FFMpeg $ffmpeg)
    {
        $this->shahidable = $shahidable;
        $this->ffmpeg = $ffmpeg;
        $this->id = $shahidable->getID();
        $this->name = $shahidable->getNAME();
        $this->parser = new ParserFacade();
    }

    /**
     * @return bool
     * @deprecated
     */
    public static function isPhpSupportedVersion()
    {
        return version_compare(PHP_VERSION, self::MIN_PHP_VERSION, '>=') && version_compare(PHP_VERSION, self::MAX_PHP_VERSION, '<');
    }

    /**
     * @param \FFMpeg\FFMpeg $ffmpeg
     * @param \Shahid\Video\shahidable $shahidable
     *
     * @throws \GuzzleHttp\Exception\GuzzleException
     * @deprecated
     */
    public static function downloadNow(FFMpeg $ffmpeg, shahidable $shahidable)
    {
        (new static($shahidable, $ffmpeg))->download($shahidable->name, $shahidable->getDefaultQuality());
    }

    /**
     * @param null $fileName
     * @param null $default_quality
     *
     * @return false
     * @throws \GuzzleHttp\Exception\GuzzleException
     * @deprecated
     */
    public function download($fileName = null, $default_quality = null)
    {
        console::text("<info>{$this->name}</info>");
        if (!$this->getId()) {
            console::text("<error>URL is invalid or not supported !</error> : <info>\r\n{$this->shahidable->url}</info>");
            return false;
        }
        preg_match('/.+: (\d+)/', shell_exec('chcp'), $matches);
        $chcp = $matches[1] ?? 65001;
        if (!$quality = (clone $this)->quality($default_quality, $quality)) return false;
        shell_exec("chcp {$chcp}");
        $my_video = new VideoMy($quality->getUri(), $this->ffmpeg->getFFMpegDriver(), $this->ffmpeg->getFFProbe());
        $extra_title = "_[{$quality->p()}][{$quality->bps()}]";
        $fileName = !empty($fileName) ? "{$fileName}{$extra_title}.mp4" : $this->fileName($extra_title);
        console::text("<question>{$quality}</question>");
        console::text("<comment>Downloading: </comment><info>{$this->name}</info>");
        $format = new X264My();
        $format->setAdditionalParameters([
            '-c', 'copy',
            '-bsf:a',
            'aac_adtstoasc',
        ]);
        $format->on('progress', function ($video, $format, $percentage) use ($fileName) {
            console::progressBar($percentage);
        });
        $my_video->save($format, $fileName);
    }

    /**
     * @return int|mixed
     * @deprecated
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param null $quality
     * @param null $selected_quality
     *
     * @return false|Quality
     * @throws \GuzzleHttp\Exception\GuzzleException
     * @deprecated
     */
    public function quality($quality = null, &$selected_quality = null)
    {
        $response = WebClient::client()->request('GET', $this->getM3u8_1080());
        $content = $response->getBody()->getContents();
        if (0) file_put_contents('test_' . date('Ymd_His') . '.txt', "{$this->getM3u8()}\n\n{$this->getM3u8_1080()}\n\n" . $content);
        /**
         * XML checking (.ism)
         */
        if (@simplexml_load_string($content)) {
            console::text("<error>Video format is not supported !</error> : <info>{$this->getName()}</info>");
            return false;
        }
        if (0/*ism*/) {
            $crawler = new Crawler($content);
            foreach ($crawler->children('StreamIndex[Type="video"]')->first()->children('QualityLevel') as $QualityLevel) {
                $QualityLevel->attr('Bitrate');
                $QualityLevel->attr('MaxHeight');
                $qualities[] = $Quality = new Quality($QualityLevel['RESOLUTION'], $QualityLevel['BANDWIDTH'], "{$this->dirname()}{$QualityLevel['uri']}");
            }
        }
        $mediaPlaylist = $this->parser->parse(new TextStream($content));
        /**
         * @var \Illuminate\Support\Collection|\Shahid\Video\Quality[] $qualities
         */
        $qualities = collect();
        $ask = [];
        $user_choice = null;
        foreach ($mediaPlaylist->offsetGet('EXT-X-STREAM-INF') as $item) {
            if (empty($item['RESOLUTION'])) continue;
            $qualities->push([
                'QUALITY' => $Quality = new Quality($item['RESOLUTION'], $item['BANDWIDTH'], "{$this->dirname()}{$item['uri']}"),
                'HEIGHT' => $Quality->getHeight(),
                'BANDWIDTH' => $Quality->getBandwidth(),
            ]);
        }
        $qualities = $qualities->sortByDesc('HEIGHT')->sortByDesc('BANDWIDTH')->values();
        switch ($quality) {
            case 'best':
                $user_choice = $qualities->first();
                break;
            case 'worst':
                $user_choice = $qualities->last();
                break;
            default:
                if (!empty($quality)) {
                    if (($qlts = $qualities->where('HEIGHT', $quality))->count())
                        $user_choice = $qlts->first();
                    else goto ask;
                } else {
                    ask:
                    $qualities->pluck('QUALITY')->each(function ($Quality) use (&$ask) {
                        /**
                         * @var Quality $Quality
                         */
                        $ask[] = "Quality {$Quality}";
                    });
                }
                break;
        }
        if ($user_choice) {
            return $user_choice['QUALITY'];
        } else {
            $selected = UserChose::chose($ask);
            return $qualities[$selected]['QUALITY'];
        }
    }

    /**
     * @return mixed
     * @throws \GuzzleHttp\Exception\GuzzleException
     * @deprecated
     */
    public function getM3u8_1080()
    {
        if ($this->m3u8_1080) return $this->m3u8_1080;
        $this->getM3u8();
        return $this->m3u8_1080;
    }

    /**
     * @return string|null
     * @throws \GuzzleHttp\Exception\GuzzleException
     * @deprecated
     */
    public function getM3u8()
    {
        if ($this->m3u8) return $this->m3u8;
        $this->json = json_decode($playoutData = $this->playoutData(), 0);
        if (0) file_put_contents('playout_' . date('Ymd_His') . '.json', $this->playoutData());
        $this->playout = $this->json->playout;
        $this->m3u8 = $this->playout->url ?? null;
        $this->m3u8_1080 = str_replace(['_720', '-720'], ['_1080', '-1080'], $this->m3u8);
        return $this->m3u8;
    }

    /**
     * @return string|null
     * @throws \GuzzleHttp\Exception\GuzzleException
     * @deprecated
     */
    protected function playoutData()
    {
        if (!$this->getId()) return null;
        $response = null;
        try {
            $response = WebClient::client()->request('GET', $this->apiUrl());
            if ($response->getStatusCode() == 200) return $response->getBody()->getContents();
            else throw new  \Exception($response->getBody(), $response->getStatusCode());
        } catch (\GuzzleHttp\Exception\ClientException $e) {
            $response = $e->getResponse();
            $responseBodyAsString = $response->getBody()->getContents();
            if (empty($responseBodyAsString)) die;
            $json = json_decode($responseBodyAsString);
            switch ($response->getStatusCode()) {
                case 422:
                    if (console::isCli()) console::text("<error>{$json->faults[0]->internalMessage}</error> : <info>{$json->faults[0]->userMessage}</info>");
                    else dd([$json->faults[0]->internalMessage => $json->faults[0]->userMessage]);
                    break;
            }
            die;
        } catch (\Exception $exception) {
            if (console::isCli()) console::text("<error>{$exception->getCode()}: {$exception->getMessage()}</error><info>");
            else dd([$exception->getCode() => $exception->getMessage()]);
            die;
        }
    }

    /**
     * @return mixed|null
     * @deprecated
     */
    protected function apiUrl()
    {
        if (!$this->getId()) return null;
        return str_replace('{id}', $this->getId(), $this->shahidable::API_URL);
    }

    /**
     * @return mixed|string
     * @deprecated
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @return mixed|string|null
     * @throws \GuzzleHttp\Exception\GuzzleException
     * @deprecated
     */
    public function dirname()
    {
        $dirname = pathinfo($this->getM3u8())['dirname'] ?? null;
        return $dirname ? "{$dirname}/" : null;
    }

    /**
     * @param null $quality
     *
     * @return string
     * @deprecated
     */
    public function fileName($quality = null)
    {
        return $this->getName() . "{$quality}.mp4";
    }
}