<?php
/**
 * User: MHK
 * Date: 19/05/2021
 */

namespace Shahid\Video;

/**
 * Class Subtitle
 * @package Shahid\Video
 */
class Subtitle
{
    protected $URI;
    protected $GROUP_ID;
    protected $NAME;
    protected $LANGUAGE;
    protected $DEFAULT;
    protected $AUTOSELECT;
    protected $FORCED;

    /**
     * Subtitle constructor.
     *
     * @param $URI
     * @param $GROUP_ID
     * @param $NAME
     * @param $LANGUAGE
     * @param string $DEFAULT
     * @param string $AUTOSELECT
     * @param string $FORCED
     */
    function __construct($URI, $GROUP_ID, $NAME, $LANGUAGE, $DEFAULT = 'NO', $AUTOSELECT = 'NO', $FORCED = 'NO')
    {
        $this->URI = $URI;
        $this->GROUP_ID = $GROUP_ID;
        $this->NAME = $NAME;
        $this->LANGUAGE = $LANGUAGE;
        $this->DEFAULT = $DEFAULT;
        $this->AUTOSELECT = $AUTOSELECT;
        $this->FORCED = $FORCED;
    }

    /**
     * @return mixed
     */
    public function getURI()
    {
        return $this->URI;
    }

    /**
     * @return mixed
     */
    public function getGROUPID()
    {
        return $this->GROUP_ID;
    }

    /**
     * @return bool
     */
    public function isDEFAULT()
    {
        return $this->DEFAULT == 'YES';
    }

    /**
     * @return bool
     */
    public function isAUTOSELECT()
    {
        return $this->AUTOSELECT == 'YES';
    }

    /**
     * @return bool
     */
    public function isFORCED()
    {
        return $this->FORCED == 'YES';
    }

    /**
     * @return float|int
     */
    public function index()
    {
        return $this->getLANGUAGE();
    }

    /**
     * @return mixed
     */
    public function getLANGUAGE()
    {
        return $this->LANGUAGE;
    }

    /**
     * @return string
     */
    public function __toString()
    {
        return "Subtitle: {$this->getNAME()}";
    }

    /**
     * @return mixed
     */
    public function getNAME()
    {
        return $this->NAME;
    }
}