<?php

namespace Shahid\Api;


abstract class Token
{
    const FILE_NAME = 'token.txt';

    /**
     * @return bool
     */
    public static function exists()
    {
        return self::get() !== null;
    }

    public static function get()
    {
        return self::file_exists() ? (!empty(self::file_get_contents()) ? self::file_get_contents() : null) : null;
    }

    /**
     * @return bool
     */
    protected static function file_exists()
    {
        return file_exists(self::FILE_NAME);
    }

    /**
     * @return false|string
     */
    protected static function file_get_contents()
    {
        return file_get_contents(self::FILE_NAME);
    }

    /**
     * @return array
     */
    public static function header()
    {
        return self::exists() ? ['token' => self::get()] : [];
    }
}