<?php

namespace Shahid\Command;

use Symfony\Component\Console\Application;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\Console\Question\ChoiceQuestion;

class UserChose extends Command
{
    public $choise = null;
    protected $choises = [];
    protected $default_answer = 0;

    /**
     * UserChose constructor.
     *
     * @param array $choises
     * @param int $default_answer
     * @param string|null $name
     */
    public function __construct($choises = [], $default_answer = 0, string $name = null)
    {
        $this->choises = $choises;
        $this->default_answer = $default_answer;
        parent::__construct($name);
    }

    /**
     * @param array $choises
     * @param int $default_answer
     *
     * @return int
     * @throws \Exception
     */
    public static function chose($choises = [], $default_answer = 0)
    {
        $app = new Application();
        $app->setAutoExit(false);
        $app->add($static = new static($choises, $default_answer));
        $app->setDefaultCommand($static->getName());
        $app->run();
        return $static->choise;
    }

    /**
     * @return UserChose
     */
    protected function configure()
    {
        return $this->setName("UserChose");
    }

    /**
     * @param InputInterface $input
     * @param OutputInterface $output
     *
     * @return int|mixed
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $helper = $this->getHelper('question');
        $question = new ChoiceQuestion(
            "Please select your choise" . (isset($this->choises[$this->default_answer]) ? " (defaults to \"{$this->choises[$this->default_answer]}\")" : null),
            $this->choises,
            $this->default_answer
        );
        $question->setErrorMessage('Choise %s is invalid.');
        $color = $helper->ask($input, $output, $question);
        $search = collect($this->choises)->search($color);
        $this->choise = $search !== null ? $search : $this->default_answer;
        return $this->choise;
    }
}