<?php

namespace Shahid\Video;


use GuzzleHttp\Client;
use Shahid\Api\Token;

/**
 * Class WebClient
 * @package Shahid\Video
 * @author MHK
 */
abstract class WebClient
{
    /**
     * @var \GuzzleHttp\Client
     */
    protected static $client;

    /**
     * @param null $shahid_os
     * @param null $os_version
     *
     * @return Client
     */
    public static function client($shahid_os = null, $os_version = null)
    {
        $shahid_os = $shahid_os ?? 'ANDROID';
        $os_version = $os_version ?? '4';
        /**
         * MPD:
         * shahid_os: WINDOWS / ANDROID 5+
         *
         * M3U8:
         * shahid_os: ANDROID 1..4 / IOS
         *
         * mediaFormat:
         *      WINDOWS      : DASH
         *      ANDROID 5+   : DASH
         *      ANDROID 1..4 : null
         *      IOS          : HLS  >>> ExecutionFailureException
         */
        if (is_null(self::$client))
            self::$client = new Client([
                'headers' => array_merge([
                    'shahid_os' => $shahid_os,
                    'os_version' => $os_version,
                    'authority' => 'api2.shahid.net',
                    'accept' => 'application/json',
                    'content-type' => 'application/json',
                    'referer' => 'https://shahid.mbc.net/',
                    'origin' => 'https://shahid.mbc.net',
                    /*'user-agent' => 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/88.0.4324.182 Safari/537.36',
                    'browser_name' => 'CHROME',
                    'browser_version' => '88.0',
                    'uuid' => 'web',
                    'shahid_os' => 'WINDOWS',
                    'os_version' => '10',*/
                ], Token::header()),
            ]);
        return self::$client;
    }
}