<?php

namespace Shahid\Video;
/**
 * Class shahidable
 * @package Shahid\Video
 */
abstract class shahidable
{
    const API_URL = null;
    const URLS = [];
    public $url;
    public $name;
    protected $default_quality;
    protected $default_audio;
    protected $default_subtitle;
    protected $index = -1;

    /**
     * shahidable constructor.
     *
     * @param $url
     * @param null $name
     * @param null $default_quality 'best' 'worst' '1080' '1080p' '720p' '468' ...
     * @param null $default_audio 'ar' 'en' 'it' ...
     * @param null $default_subtitle 'ar' 'en' 'it' ...
     */
    public function __construct($url, $name = null, $default_quality = null, $default_audio = null, $default_subtitle = null)
    {
        $this->url = $url;
        $this->name = $name;
        $this->default_quality = $default_quality;
        $this->default_audio = $default_audio;
        $this->default_subtitle = $default_subtitle;
        $this->setIndex();
    }

    protected function setIndex()
    {
        foreach ($this::URLS as $index => $URL) {
            preg_match($URL['ID_URL'], $this->url, $matches);
            if (count($matches)) {
                $this->index = $index;
                break;
            }
        }
    }

    /**
     * @return null
     */
    public function getDefaultAudio()
    {
        return $this->default_audio;
    }

    /**
     * @return null
     */
    public function getDefaultSubtitle()
    {
        return $this->default_subtitle;
    }

    /**
     * @return null
     */
    public function getDefaultQuality()
    {
        return $this->default_quality;
    }

    /**
     * @return mixed|null
     */
    public function getID()
    {
        if (!$this->getID_URL()) return null;
        preg_match($this->getID_URL(), $this->url, $matches);
        return $matches[1] ?? null;
    }

    /**
     * @return mixed|null
     */
    protected function getID_URL()
    {
        return $this::URLS[$this->index]['ID_URL'] ?? null;
    }

    /**
     * @return string|null
     */
    public function getNAME()
    {
        if (!$this->getNAME_URL()) return null;
        preg_match($this->getNAME_URL(), $this->url, $matches);
        return urldecode($matches[1]) ?? null;
    }

    /**
     * @return mixed|null
     */
    protected function getNAME_URL()
    {
        return $this::URLS[$this->index]['NAME_URL'] ?? null;
    }
}